

menu = true
instr = false
Menubg = image.load("images/menu.png")
Tabs = image.load("images/tabs.png")
Bpush = image.load("images/bpush.png")
Instrument = image.load("images/instrument.png")
Wpush1 = image.load("images/wpush1.png")
Wpush2 = image.load("images/wpush2.png")
Wpush3 = image.load("images/wpush3.png")
error = wav.load("images/error.wav")
current = 1
f = 0
time = 0
math.randomseed(os.time())    
I = {"Piano","Synthesizer","Uprightbass","Organ"}

function LoadInstrument() 
	screen.fillrect(0,0,400,240,color.new(0,0,0))
	text.color(color.new(255,255,255))
	text.draw(0,100,"Loading files...","center")
	screen.update()
	Play = {wav.load(I[current].."/1.wav"),
			wav.load(I[current].."/2.wav"),
			wav.load(I[current].."/3.wav"),
			wav.load(I[current].."/4.wav"),
			wav.load(I[current].."/5.wav"),
			wav.load(I[current].."/6.wav"),
			wav.load(I[current].."/7.wav"),
			wav.load(I[current].."/8.wav"),
			wav.load(I[current].."/9.wav"),
			wav.load(I[current].."/10.wav"),
			wav.load(I[current].."/11.wav"),
			wav.load(I[current].."/12.wav"),
			wav.load(I[current].."/13.wav")}
end 

function Volume()while 1 do

	local oldsize=text.size(16)		--save text size to set it back later, and for now use size 16
	local sheight=screen.height()	--get the current screen height (depends on screen orientation)
	local swidth=screen.width()		--get the current screen width (depends on screen orientation)


		screen.fillrect(swidth-30,sheight-220,30,210,color.new(0,0,0))																--black background
		text.draw(swidth-27,sheight-218,audio.volume(),"center")																	--text.draw current volume level
		screen.drawrect(swidth-20,sheight-201,swidth-10,sheight-20,color.new(255,255,255)) 											--frame of volume bar
		screen.fillrect(swidth-18,(sheight-200)+(180-(180*(audio.volume()/25))),7,180*(audio.volume()/25),color.new(155,155,155)) 	--volume bar
		screen.update()

		if control.read(1) then
			if control.isButton()==1 and button.event()==1 then
				break														--use home button click to end this function
			elseif control.isTouch()==1 then
				touch_x,touch_y=touch.pos()
				if touch.event()==2 then 									-- =touch.down
					if touch_x>=(swidth-30) and touch_y>=(sheight-220) then		--if you touched somewhere in the volume control window
						if touch_y>=(sheight-200) and touch_y<=(sheight-20) then	--if you touched within the frame of the volume bar,
							audio.volume(math.floor(((touch_y-(sheight-20))/7)*-1))		--calculate where you touched and set the volume at that level
						elseif touch_y<(sheight-200) then							--if you touched just above the volume bar,
							audio.volume(25)											--set volume to 25
						elseif touch_y>(sheight-20) then 							-- if you touched just below the volume bar,
							audio.volume(0)												--set volume to 0
						end
					end
				elseif touch.event()==4 then								-- =touch.click
					if touch_x<swidth-30 or touch_y<sheight-220 then			--if you clicked outside the volume control window,
						break														--end this function
					else
						audio.beep(440,100)										--after tapping the volume bar, play beep (or replace this with a nice sound)
					end
				elseif touch.event()==32 and touch_x>=(swidth-30) and touch_y>sheight-200 and touch_y<sheight-20 then	--if you moved within the frame of the volume bar
					audio.volume((math.floor((touch_y-(sheight-200))/7)-25)*-1)	--calculate the position where you are moving, and set the volume at that level
					for i=0, 50 do
						control.read()												--clear queque for smooth movements
					end
				elseif touch.event()==1 then								-- =touch.up
					audio.beep(440,100)											--after scrolling the volume bar, play beep (or replace this with a nice sound)
				end
			end
		end

	end

end

function CloseInstrument() 
	screen.fillrect(0,0,400,240,color.new(0,0,0))
	text.color(color.new(255,255,255))
	text.draw(0,100,"Closing files...","center")
	screen.update()
	for i = 1, 13, 1 do
		wav.close(Play[i])
	end 
end

function Menu()
	x = nil
	y = nil
	Menubg:draw(0,0)
	white = nil
end

function Instr()
	Instrument:draw(0,0)      
	text.color(color.new(255,0,0))
	text.size(100)
	text.draw(150,120,current)
	for i = 0, table.getn(I)-1, 1 do  
		text.size(15)
		if i+1 == current then 
			text.size(17)
		end
		text.draw(35,25+20*i,(i+1).." "..I[i+1])
		text.draw(35,24+20*i,(i+1).." "..I[i+1])
		text.draw(34,25+20*i,(i+1).." "..I[i+1])
		screen.drawline(27,23+20*(i+1),218,23+20*(i+1),color.new(255,0,0))
	end
end

function Touchcontrol()
	if menu == true then
		if x < 150 and y > 150 then
			menu = false  
			instr = false 
			CloseInstrument()  
			LoadInstrument()
			Tabs:draw(0,0)  
		elseif x > 260 and y < 70 then
			instr = true
			menu = false
		end 
	elseif instr == true then
		if x > 300 and y > 180 then
			menu = true
			intr = false
		elseif x > 250 and y < 150 then
			wav.play(Play[math.random(13)])
		end
		for h = 0, 2, 1 do
			if y > 125+35*h and y < 125+35*(h+1) then
				for i = 0, 2, 1 do
					if x > 20+35*i and x < 20+35*(i+1) then 
						if table.getn(I) < i+1+h*3 then
							wav.play(error)
						else
							current = i+1+h*3
						end
					end
				end
			end
		end
		for i = 0, table.getn(I)-1, 1 do
		    if x > 35 and x < 220 and y > 25+20*i and y < 25+20*(i+1) then
		        current = i+1
			end
		end     
	else
		white = true
		for i = 0, 6, 1 do
	        if x > 35+i*28+22*i and x < 35+(i+1)*28+23*i and y < 150 then 
				if i<2 then
					v = 1
				else
					v = 0 
				end       
				if i ~= 2 and i ~= 6 then
					if playing ~= i+v+8 then
				    	new = true
					    playing = i+v+8
						wav.play(Play[(i+v+8)])
	           			white = false
	            		break
	           		end     
	            white = false
	           	end
			end
		new = false
		end		
		if white ~= false then
		    for i = 0, 8, 1 do  
		        if x > i*50 and x < (i+1)*50 then  
					if playing ~= i+1 then
					    new = true
						playing = i+1
		            	wav.play(Play[(i+1)]) 
		            	break
		            end
				end
				new = false
			end
		end
	end
end

LoadInstrument()
while true do
	if menu == true then
		Menu()
	elseif instr == true then
		Instr()
	else
	    if f <= 5 or new == true then
	    	if new == true then
	       		Tabs:draw(0,0)
	       	end
	       	if playing ~= nil then
	        	if white == false then
					Bpush:draw(38+(playing-v-8)*50,1)
				else
					if playing == 1 or playing == 4 or playing == 8 then
				    	Wpush1:draw(2+50*(playing-1),3)
					elseif playing == 2 or playing == 5 or playing == 6 then
				    	Wpush2:draw(2+50*(playing-1),3)
					elseif playing == 3 or playing == 7 then
				    	Wpush3:draw(2+50*(playing-1),3)
					end
				end
			end
	        new = false
		    f = f+1
		elseif (new == false and f == 10) or touch.up() == 1 or click == true then
	        Tabs:draw(0,0)
		end
	end             
	if touch.down() == 1 then 
		playing = nil
		click = true
		x, y = touch.pos() 
	    if skip ~= true then  
			Touchcontrol() 
		else               
		    skip = false
		end     
		skip = true  
		f = 0
	else               
		new = nil 
		skip = false
	end      
	if control.read()==1 then
		if control.isTouch() == 1 then
			if touch.click() == 1 then
				if click ~= true then
				    playing = nil
					x, y = touch.pos()  
					Touchcontrol()
					new = nil
	    			f = 0
	    			click = true
	    		end
			elseif touch.move() == 1 then
			    x, y = touch.pos()  
			    f = 0
			    if skip ~= true then
					Touchcontrol()
				else
				    skip = false
				end             
				click = false
			else
				click = false
			end
		elseif control.isButton()== 1 then
			if button.click() == 1 then
				if menu == true then
					break
				else
					instr = false
					menu = true
				end
			elseif button.hold() == 1 then
			    Volume()
			end
		end
	else
	 	os.sleep(1)
	end      
	screen.update()
end

CloseInstrument()